/**
* @module @promises/_create-filter
* @copyright © 2017 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
* @license MIT
*/
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (factory((global.P = global.P || {})));
}(this, (function (exports) { 'use strict';

    function _createFilter(iterator, is) {
        return function (collection, iteratee, limit) {
            if (iteratee === void 0) { iteratee = function (v) { return v; }; }
            return Promise.resolve(collection).then(function (collection) {
                if (collection === void 0) { collection = []; }
                var isArray = Array.isArray(collection);
                var result = isArray ? [] : {};
                var count = 0;
                return iterator(collection, function (value, key, collection) {
                    var isPass = iteratee(value, key, collection);
                    return Promise.resolve(isPass).then(function (isPass) {
                        if (!!isPass === is)
                            result[isArray ? count++ : key] = value;
                    });
                }, limit).then(function () {
                    return result;
                });
            });
        };
    }

    exports.default = _createFilter;

    Object.defineProperty(exports, '__esModule', { value: true });

    exports.createFilter = exports.default;

})));
//# sourceMappingURL=bundle.umd.js.map
