"use strict";
/**
 * @module @promises/_create-filter
 * @copyright © 2017 Yisrael Eliav <yisraelx@gmail.com> (https://github.com/yisraelx)
 * @license MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @function
 * @private
 */
function _createFilter(iterator, is) {
    return function (collection, iteratee, limit) {
        if (iteratee === void 0) { iteratee = function (v) { return v; }; }
        return Promise.resolve(collection).then(function (collection) {
            if (collection === void 0) { collection = []; }
            var isArray = Array.isArray(collection);
            var result = isArray ? [] : {};
            var count = 0;
            return iterator(collection, function (value, key, collection) {
                var isPass = iteratee(value, key, collection);
                return Promise.resolve(isPass).then(function (isPass) {
                    if (!!isPass === is)
                        result[isArray ? count++ : key] = value;
                });
            }, limit).then(function () {
                return result;
            });
        });
    };
}
exports.default = _createFilter;
//# sourceMappingURL=index.js.map